<template>
  <v-dialog v-model="show" max-width="480px">
    <v-card>
      <v-card-title>
        {{ value.title }}
      </v-card-title>
      <v-card-text>
        <v-form ref="form" v-model="valid" lazy-validation>
          <div style="padding:10px">
            <label>
              Finance Name*
            </label>
            <v-text-field
              v-model="name"
              :rules="rules"
              placeholder="Input your finance name"
              required
            ></v-text-field>

            <label>
              Finance Account*
            </label>
            <v-autocomplete
              item-text="name"
              item-value="id"
              v-model="account"
              :items="listAccount"
              :rules="rules"
              placeholder="Select finance account"
            ></v-autocomplete>

            <label>
              Amount*
            </label>
            <v-text-field
              prefix="Rp "
              v-model="amount"
              type="number"
              placeholder="Input your amount"
              :rules="numberRule"
              required
            ></v-text-field>

            <label>
              Description*
            </label>
            <v-text-field
              v-model="description"
              :rules="rules"
              placeholder="Input your description"
            ></v-text-field>
          </div>

          <div align="right">
            <v-btn
              color="#babbba"
              outlined
              rounded
              @click.stop="show = false"
              class="btn-custom"
            >
              Batal
            </v-btn>

            &nbsp;

            <v-btn
              color="#90ba45"
              rounded
              dark
              :loading="loading"
              @click="insertData()"
              class="btn-custom"
            >
              Simpan
            </v-btn>
          </div>
        </v-form>
      </v-card-text>
    </v-card>
  </v-dialog>
</template>

<script>
export default {
  props: { value: { type: Object } },

  computed: {
    show: {
      get() {
        let self = this;
        self.clear();
        if (self.value["data"]) {
          self.name = self.value["data"]["title"];
          self.account = self.value["data"]["finance_account_id"];
          self.amount = self.value["data"]["debit_amount"];
          self.description = self.value["data"]["description"];
        }
        return self.value["val"];
      },
      set(value) {
        this.$emit("input", value);
      },
    },
  },
  methods: {
    processForm() {
      let value = this.comment;
      this.$emit("event", value);
    },
    async insertData() {
      let self = this;
      let res = null;
      self.loading = true;

      try {
        if (self.$refs.form.validate()) {
          let url = self.base_url + "api/v1/finances";
          let data = {
            title: self.name,
            debit_amount: parseInt(self.amount),
            credit_amount: parseInt(self.amount),
            description: self.description,
            finance_account_id: self.account,
          };

          if (self.value.tipe == "insert") {
            res = await self.axios.post(url, data, {
              headers: {
                Authorization: "Bearer " + self.token,
                "Content-Type": "application/json;charset=UTF-8",
              },
            });
          } else {
            url = self.base_url + "api/v1/finances/" + this.value["data"]["id"];
            res = await self.axios.put(url, data, {
              headers: {
                Authorization: "Bearer " + self.token,
                "Content-Type": "application/json;charset=UTF-8",
              },
            });
          }
        }
      } catch (err) {
        alert(JSON.stringify(err.response.data));
      } finally {
        self.finish(res);
      }
    },
    async getAccount() {
      let self = this;
      let sort_field = self.sort_field;
      let sort_type = self.sort_type;
      let page = self.page;
      let per_page = self.per_page;
      let description = self.description;

      let url =
        self.base_url +
        "api/v1/finance-accounts?description=" +
        description +
        "&sort_field=" +
        sort_field +
        "&sort_type=" +
        sort_type +
        "&page=" +
        page +
        "&per_page=" +
        per_page;

      self.axios
        .get(url, {
          headers: {
            Authorization: "Bearer " + self.token,
            "Content-Type": "application/json;charset=UTF-8",
          },
        })
        .then(function(response) {
          self.listAccount = response.data["data"];
        });
    },
    finish(e) {
      this.loading = false;
      this.$emit("event", e);
      this.clear();
      console(e);
    },
    clear() {
      this.name = "";
      this.account = "";
      this.amount = "";
      this.description = "";
    },
  },
  mounted() {
    this.getAccount();
  },
  data: function() {
    return {
      loading: false,
      rules: [(v) => !!v || "Form is required"],
      numberRule: [(v) => !!v || "Form is required"],
      token: localStorage.getItem("token"),
      listAccount: [],
      description: "",
      sort_field: "name",
      sort_type: 1,
      page: 0,
      per_page: 100,
    };
  },
};
</script>
